شروع سریع Google Analytics API

برای این شروع سریع می‌توانید از میانای برنامه‌سازی کاربردی داده یا میانای برنامه‌سازی کاربردی سرپرست استفاده کنید

انتخاب یک API: Data API Admin API

می‌توانید با حساب کاربری یا حساب سرویس اصالت‌سنجی کنید:

نوع حساب را انتخاب کنید:

در این شروع سریع، یک درخواست runReport ایجاد و ارسال می‌کنید.

در اینجا خلاصه مراحل آمده است:

  1. ابزارها و دسترسی را راه‌اندازی کنید.
  2. میانای برنامه‌سازی کاربردی را فعال کنید.
  3. کیت توسعه نرم‌افزار نصب کنید.
  4. تماس با API برقرار کنید.

قبل‌از شروع

  1. ‫CLI‏ gcloud را نصب و مقداردهی اولیه کنید.

  2. برای تولید اعتبارنامه‌های پیش‌فرض برنامه و دادن دامنه‌های لازم به حسابتان، دستور زیر را اجرا کنید:

    gcloud auth application-default login --scopes="https://www.googleapis.com/auth/cloud-platform,https://www.googleapis.com/auth/analytics.readonly"
    
  3. در واسط کاربر Google Analytics، به حساب کاربری خود دسترسی به دارایی Google Analytics را اعطا کنید.

فعال کردن Data API

برای انتخاب یا ایجاد پروژه Google Cloud و فعال کردن میانای برنامه‌سازی کاربردی، روی فعال کردن Google Analytics Data API v1 کلیک کنید.

فعال کردن Google Analytics API

نصب کیت توسعه نرم‌افزار

«کیت توسعه نرم‌افزار» را برای زبان برنامه‌نویسی‌تان نصب کنید.

جاوا

راهنمای نصب کتابخانه مشتری Java

PHP

راهنمای نصب کتابخانه مشتری PHP

Python

راهنمای نصب کتابخانه مشتری Python

Node.js

راهنمای نصب کتابخانه مشتری Node.js

دات نت

راهنمای نصب کتابخانه مشتری.NET

Ruby

راهنمای نصب کتابخانه مشتری Ruby

رفتن

go get google.golang.org/genproto/googleapis/analytics/data/v1beta

REST

با وارد کردن موارد زیر، متغیرهای محیطی‌تان را پیکربندی کنید. PROJECT_ID را با شناسه پروژه و PROPERTY_ID را با شناسه دارایی Google Analytics خودتان جایگزین کنید.

  export PROJECT_ID=PROJECT_ID
  export PROPERTY_ID=PROPERTY_ID

فراخوانی API

برای درستی‌سنجی تنظیمات و برقراری تماس با API، نمونه زیر را اجرا کنید.

این نمونه روش runReport را فرا می‌خواند. پاسخ، کاربران فعال دارایی‌تان را فهرست می‌کند.

برای نصب همه نمونه‌های کد Analytics API، به GitHub ما مراجعه کنید.

جاوا

import com.google.analytics.data.v1beta.BetaAnalyticsDataClient;
import com.google.analytics.data.v1beta.DateRange;
import com.google.analytics.data.v1beta.Dimension;
import com.google.analytics.data.v1beta.Metric;
import com.google.analytics.data.v1beta.Row;
import com.google.analytics.data.v1beta.RunReportRequest;
import com.google.analytics.data.v1beta.RunReportResponse;

/**
 * Google Analytics Data API sample quickstart application.
 *
 * <p>This application demonstrates the usage of the Analytics Data API using service account
 * credentials.
 *
 * <p>Before you start the application, please review the comments starting with "TODO(developer)"
 * and update the code to use correct values.
 *
 * <p>To run this sample using Maven:
 *
 * <pre>{@code
 * cd google-analytics-data
 * mvn compile exec:java -Dexec.mainClass="com.google.analytics.data.samples.QuickstartSample"
 * }</pre>
 */
public class QuickstartSample {

  public static void main(String... args) throws Exception {
    /**
     * TODO(developer): Replace this variable with your Google Analytics 4 property ID before
     * running the sample.
     */
    String propertyId = "YOUR-GA4-PROPERTY-ID";
    sampleRunReport(propertyId);
  }

  // This is an example snippet that calls the Google Analytics Data API and runs a simple report
  // on the provided GA4 property id.
  static void sampleRunReport(String propertyId) throws Exception {
    // Using a default constructor instructs the client to use the credentials
    // specified in GOOGLE_APPLICATION_CREDENTIALS environment variable.
    try (BetaAnalyticsDataClient analyticsData = BetaAnalyticsDataClient.create()) {

      RunReportRequest request =
          RunReportRequest.newBuilder()
              .setProperty("properties/" + propertyId)
              .addDimensions(Dimension.newBuilder().setName("city"))
              .addMetrics(Metric.newBuilder().setName("activeUsers"))
              .addDateRanges(DateRange.newBuilder().setStartDate("2020-03-31").setEndDate("today"))
              .build();

      // Make the request.
      RunReportResponse response = analyticsData.runReport(request);

      System.out.println("Report result:");
      // Iterate through every row of the API response.
      for (Row row : response.getRowsList()) {
        System.out.printf(
            "%s, %s%n", row.getDimensionValues(0).getValue(), row.getMetricValues(0).getValue());
      }
    }
  }
}

PHP

require 'vendor/autoload.php';

use Google\Analytics\Data\V1beta\Client\BetaAnalyticsDataClient;
use Google\Analytics\Data\V1beta\DateRange;
use Google\Analytics\Data\V1beta\Dimension;
use Google\Analytics\Data\V1beta\Metric;
use Google\Analytics\Data\V1beta\RunReportRequest;

/**
 * TODO(developer): Replace this variable with your Google Analytics 4
 *   property ID before running the sample.
 */
$property_id = 'YOUR-GA4-PROPERTY-ID';

// Using a default constructor instructs the client to use the credentials
// specified in GOOGLE_APPLICATION_CREDENTIALS environment variable.
$client = new BetaAnalyticsDataClient();

// Make an API call.
$request = (new RunReportRequest())
    ->setProperty('properties/' . $property_id)
    ->setDateRanges([
        new DateRange([
            'start_date' => '2020-03-31',
            'end_date' => 'today',
        ]),
    ])
    ->setDimensions([new Dimension([
            'name' => 'city',
        ]),
    ])
    ->setMetrics([new Metric([
            'name' => 'activeUsers',
        ])
    ]);
$response = $client->runReport($request);

// Print results of an API call.
print 'Report result: ' . PHP_EOL;

foreach ($response->getRows() as $row) {
    print $row->getDimensionValues()[0]->getValue()
        . ' ' . $row->getMetricValues()[0]->getValue() . PHP_EOL;
}

Python

from google.analytics.data_v1beta import BetaAnalyticsDataClient
from google.analytics.data_v1beta.types import (
    DateRange,
    Dimension,
    Metric,
    RunReportRequest,
)


def sample_run_report(property_id="YOUR-GA4-PROPERTY-ID"):
    """Runs a simple report on a Google Analytics 4 property."""
    # TODO(developer): Uncomment this variable and replace with your
    #  Google Analytics 4 property ID before running the sample.
    # property_id = "YOUR-GA4-PROPERTY-ID"

    # Using a default constructor instructs the client to use the credentials
    # specified in GOOGLE_APPLICATION_CREDENTIALS environment variable.
    client = BetaAnalyticsDataClient()

    request = RunReportRequest(
        property=f"properties/{property_id}",
        dimensions=[Dimension(name="city")],
        metrics=[Metric(name="activeUsers")],
        date_ranges=[DateRange(start_date="2020-03-31", end_date="today")],
    )
    response = client.run_report(request)

    print("Report result:")
    for row in response.rows:
        print(row.dimension_values[0].value, row.metric_values[0].value)

Node.js

  /**
   * TODO(developer): Uncomment this variable and replace with your
   *   Google Analytics 4 property ID before running the sample.
   */
  // propertyId = 'YOUR-GA4-PROPERTY-ID';

  // Imports the Google Analytics Data API client library.
  const {BetaAnalyticsDataClient} = require('@google-analytics/data');

  // Using a default constructor instructs the client to use the credentials
  // specified in GOOGLE_APPLICATION_CREDENTIALS environment variable.
  const analyticsDataClient = new BetaAnalyticsDataClient();

  // Runs a simple report.
  async function runReport() {
    const [response] = await analyticsDataClient.runReport({
      property: `properties/${propertyId}`,
      dateRanges: [
        {
          startDate: '2020-03-31',
          endDate: 'today',
        },
      ],
      dimensions: [
        {
          name: 'city',
        },
      ],
      metrics: [
        {
          name: 'activeUsers',
        },
      ],
    });

    console.log('Report result:');
    response.rows.forEach((row) => {
      console.log(row.dimensionValues[0], row.metricValues[0]);
    });
  }

  runReport();

دات نت

using System;
using Google.Analytics.Data.V1Beta;

namespace AnalyticsSamples
{
    class QuickStart
    {
        static void SampleRunReport(string propertyId = "YOUR-GA4-PROPERTY-ID")
        {
            /**
             * TODO(developer): Uncomment this variable and replace with your
             *  Google Analytics 4 property ID before running the sample.
             */
            // propertyId = "YOUR-GA4-PROPERTY-ID";

            // Using a default constructor instructs the client to use the credentials
            // specified in GOOGLE_APPLICATION_CREDENTIALS environment variable.
            BetaAnalyticsDataClient client = BetaAnalyticsDataClient.Create();

            // Initialize request argument(s)
            RunReportRequest request = new RunReportRequest
            {
                Property = "properties/" + propertyId,
                Dimensions = { new Dimension { Name = "city" } },
                Metrics = { new Metric { Name = "activeUsers" } },
                DateRanges =
                {
                    new DateRange { StartDate = "2020-03-31", EndDate = "today" },
                },
            };

            // Make the request
            RunReportResponse response = client.RunReport(request);

            Console.WriteLine("Report result:");
            foreach (Row row in response.Rows)
            {
                Console.WriteLine(
                    "{0}, {1}",
                    row.DimensionValues[0].Value,
                    row.MetricValues[0].Value
                );
            }
        }

        static int Main(string[] args)
        {
            if (args.Length > 0)
            {
                SampleRunReport(args[0]);
            }
            else
            {
                SampleRunReport();
            }
            return 0;
        }
    }
}

REST

برای ارسال این درخواست، فرمان curl را از خط فرمان اجرا کنید یا تماس REST را در برنامه‌تان بگنجانید.

curl -X POST \
  -H "Authorization: Bearer $(gcloud auth application-default print-access-token)" \
  -H "x-goog-user-project: ${PROJECT_ID}" \
  -H "Content-Type: application/json" \
  -d '
  {
    "dateRanges": [
      {
        "startDate": "2025-01-01",
        "endDate": "2025-02-01"
      }
    ],
    "dimensions": [
      {
        "name": "country"
      }
    ],
    "metrics": [
      {
        "name": "activeUsers"
      }
    ]
  }'  https://analyticsdata.googleapis.com/v1beta/properties/${PROPERTY_ID}:runReport

در اینجا یک پاسخ نمونه در قالب JSON آورده شده است:

{
  "dimensionHeaders": [
    {
      "name": "country"
    }
  ],
  "metricHeaders": [
    {
      "name": "activeUsers",
      "type": "TYPE_INTEGER"
    }
  ],
  "rows": [
    {
      "dimensionValues": [
        {
          "value": "United States"
        }
      ],
      "metricValues": [
        {
          "value": "3242"
        }
      ]
    },
    {
      "dimensionValues": [
        {
          "value": "(not set)"
        }
      ],
      "metricValues": [
        {
          "value": "3015"
        }
      ]
    },
    {
      "dimensionValues": [
        {
          "value": "India"
        }
      ],
      "metricValues": [
        {
          "value": "805"
        }
      ]
    }
  ],
  "rowCount": 3,
  "metadata": {
    "currencyCode": "USD",
    "timeZone": "America/Los_Angeles"
  },
  "kind": "analyticsData#runReport"
}